module Nfe
  module Helpers
    class SchemaValidator
      extend ActiveModel::Naming

      attr_reader :errors

      def initialize(schema_path, xml)
        @document = Nokogiri::XML(xml)
        @xsd = Nokogiri::XML::Schema(File.open(schema_path))
        @errors = ActiveModel::Errors.new(self)
      end

      def valid?
        @xsd.validate(@document).each do |error|
          message = error.message.gsub("{http://www.portalfiscal.inf.br/nfe}", "")
          @errors.add(:base, message) unless @errors.added? :base, message
        end

        @errors.empty?
      end
    end
  end
end
