module Nfe
  module Helpers
    class Signer
      def initialize(certificate, private_key)
        @certificate = certificate
        @private_key = private_key
      end

      def execute(objeto, id)
        objeto.signature = Nfe::Models::Signature.new(id)
        document = Xmldsig::SignedDocument.new(objeto.to_xml)
        document.sign(@private_key, @certificate)
        objeto.signature.value = sign_value(document)
        objeto
      end

      private
      def sign_value(document)
        signature = document.signatures.first.signature
        value = signature.children
        value.to_xml(save_with: Nokogiri::XML::Node::SaveOptions::AS_XML)
      end
    end
  end
end
