module Nfe
  module Helpers
    module XmlModel
      class AttributeText < AttributeBase
        def format
          @format || "%s"
        end

        private

        def add_element(attribute)
          format % normalize_attribute(attribute)
        end

        def normalize_attribute(attribute)
          attribute.to_s.
            gsub(/\n/, " ").
            gsub(/\r/, " ").
            gsub(/\s+/, " ").
            gsub(/&/, "&amp;").
            gsub(/</, "&lt;").
            gsub(/>/, "&gt;").
            gsub(/\"/, "&quot;").
            gsub(/\'/, "&#39;").
            gsub(/[(ÿ-\uFFFF| )]/, " ").
            gsub(/  +/, " ")
        end
      end
    end
  end
end
