module Nfe
  module Models
    module Bill
      class Cobr
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :fat, type: :node
        attr_xml :dup, type: :collection, klass: "Nfe::Models::Bill::Dup"

        validates :dup,
          length: { maximum: 120, message: :less_than_or_equal_to }

        validate { validate_optional_attributes :fat, :dup }

        def initialize
          @fat = Fat.new
          @dup = []
        end
      end
    end
  end
end
