module Nfe
  module Models
    module Bill
      class Dup
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :nDup
        attr_xml :dVenc, type: :date
        attr_xml :vDup, type: :float

        validates :nDup,
          length: { maximum: 60 }

        validates :vDup,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true }
      end
    end
  end
end
