module Nfe
  module Models
    module Bill
      class Fat
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :nFat
        attr_xml :vOrig, type: :float
        attr_xml :vDesc, type: :float
        attr_xml :vLiq, type: :float

        validates :nFat,
          length: { maximum: 60 }

        validates :vOrig,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true }

        validates :vDesc,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true }

        validates :vLiq,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true }
      end
    end
  end
end
