module Nfe
  module Models
    module Cane
      class Deduc
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :xDed, required: true
        attr_xml :vDed, type: :float, required: true 

        validates :xDed,
          presence: true,
          length: { in: 1..60 }

        validates :vDed,
          presence: true,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99
          }
      end
    end
  end
end
