require_relative "bigdecimal_less_than_validator"
require_relative "bigdecimal_greater_than_validator"

module Nfe
  module Models
    module Cane
      class ForDia
        include ActiveModel::Validations
        include Helpers::XmlModel::NfeModel

        attr_xml :dia, type: :attribute
        attr_xml :qtde, type: :bigdecimal, required: true

        def initialize
          @qtde = BigDecimal("0", 22)
        end

        def qtde=(value)
          @qtde = BigDecimal(value, 22)
        end

        validates :dia,
          presence: true,
          length: { in: 1..2 },
          numericality: { only_integer: true }

        validates :qtde,
          bigdecimal_less_than: true,
          bigdecimal_greater_than: true
      end
    end
  end
end
