module Nfe
  module Models
    module Concerns
      module CnpjCpfValidatable
        extend ActiveSupport::Concern
        include ActiveModel::Model

        included do
          validates :cnpj,
            presence: { if: -> { self.send("cpf").blank? } },
            cnpj: true,
            length: { is: 14, allow_blank: true }

          validates :cpf,
            presence: { if: -> { self.send("cnpj").blank? } },
            cpf: true,
            length: { is: 11, allow_blank: true }
        end
      end
    end
  end
end
