module Nfe
  module Models
    class Det
      include ActiveModel::Model
      include Helpers::XmlModel::NfeModel

      attr_xml :nItem, type: :attribute
      attr_xml :prod, type: :node, required: true
      attr_xml :imposto, type: :node, required: true
      attr_xml :infAdProd

      validates :nItem,
        presence: true,
        numericality: { only_integer: true },
        length: { maximum: 3 }

      validates :prod,
        presence: true

      validates :imposto,
        presence: true

      validates :infAdProd,
        length: { maximum: 500 }

      validate { validate_optional_attributes :prod, :imposto }  

      def initialize
        @prod = Itens::Prod.new
        @imposto = Taxes::Imposto.new
      end
    end
  end
end
