module Nfe
  module Models
    class EntregaRetirada
      include ActiveModel::Model
      include Helpers::XmlModel::NfeModel
      include Concerns::CnpjCpfValidatable

      attr_xml :cnpj, xml_alias: "CNPJ"
      attr_xml :cpf, xml_alias: "CPF"
      attr_xml :xLgr, required: true
      attr_xml :nro, required: true
      attr_xml :xCpl
      attr_xml :xBairro, required: true
      attr_xml :cMun, required: true
      attr_xml :xMun, required: true
      attr_xml :uf, required: true, xml_alias: "UF"

      validates :xLgr,
        presence: true,
        length: { in: 2..60 }

      validates :nro,
        presence: true,
        length: { maximum: 60 }

      validates :xCpl,
        length: { maximum: 60 }

      validates :xBairro,
        presence: true,
        length: { in: 2..60 }

      validates :cMun,
        presence: true,
        length: { is: 7 },
        numericality: { only_integer: true }

      validates :xMun,
        presence: true,
        length: { in: 2..60 }

      validates :uf,
        presence: true,
        length: { is: 2 }
    end
  end
end
