module Nfe
  module Models
    module Information
      class ProcRef
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :nProc, required: true
        attr_xml :indProc, type: :enumerize, required: true

        extend Enumerize

        enumerize :indProc, in: { sefaz: 0, justica_federal: 1,
          justica_estadual: 2, secex_rfb: 3, others: 9 }

        validates :nProc,
          presence: true,
          length: { in: 1..60 }

        validates :indProc,
          presence: true
      end
    end
  end
end
