module Nfe
  module Models
    module Itens
      class CIDE
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :qBCProd, type: :float, required: true, format: "%0.4f"
        attr_xml :vAliqProd, type: :float, required: true, format: "%0.4f"
        attr_xml :vCIDE, type: :float, required: true

        validates :qBCProd,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 999_999_999_999.9999
          }

        validates :vAliqProd,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 99_999_999_999.9999
          }

        validates :vCIDE,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99
          }
      end
    end
  end
end
