module Nfe
  module Models
    module Itens
      class DI
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :nDI, required: true
        attr_xml :dDI, type: :date, required: true
        attr_xml :xLocDesemb, required: true
        attr_xml :ufDesemb, required: true, xml_alias: "UFDesemb"
        attr_xml :dDesemb, type: :date, required: true
        attr_xml :cExportador, required: true
        attr_xml :adi, type: :collection, klass: "Nfe::Models::Itens::Adi"

        validates :nDI,
          presence: true,
          length: { in: 1..12 }

        validates :dDI,
          presence: true,
          length: { is: 10 }

        validates :xLocDesemb,
          presence: true,
          length: { in: 1..60 }

        validates :ufDesemb,
          presence: true,
          length: { is: 2 }

        validates :dDesemb,
          presence: true,
          length: { is: 10 }

        validates :cExportador,
          presence: true,
          length: { in: 1..60 }

        validates :adi, :adi,
           length: { maximum: 100, message: :less_than_or_equal_to }

        validate { validate_optional_attributes :adi }

        def initialize
          @adi = []
        end

        def present?
          true
        end
      end
    end
  end
end
