module Nfe
  module Models
    module Itens
      class Adi
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :nAdicao, required: true
        attr_xml :nSeqAdic, required: true
        attr_xml :cFabricante, required: true
        attr_xml :vDescDI, type: :float

        validates :nAdicao,
          presence: true,
          length: { maximum: 3 }

        validates :nSeqAdic,
          presence: true,
          length: { maximum: 3 }

        validates :cFabricante,
          presence: true,
          length: { maximum: 60 }

        validates :vDescDI,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }
      end
    end
  end
end
