module Nfe
  module Models
    module Itens
      class Arma
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :tpArma, required: true
        attr_xml :nSerie, required: true
        attr_xml :nCano, required: true
        attr_xml :descr, required: true

        validates :tpArma,
          presence: true,
          inclusion: { in: ["0", "1"] }

        validates :nSerie,
          presence: true,
          length: { maximum: 9 }

        validates :nCano,
          presence: true,
          length: { maximum: 9 }

        validates :descr,
          presence: true,
          length: { maximum: 256 }
      end
    end
  end
end
