module Nfe
  module Models
    module Itens
      class Med
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :nLote, required: true
        attr_xml :qLote, type: :float, required: true, format: "%0.3f"
        attr_xml :dFab, type: :date, required: true
        attr_xml :dVal, type: :date, required: true
        attr_xml :vPMC, type: :float, required: true

        validates :nLote,
          presence: true,
          length: { maximum: 20 }

        validates :qLote,
          presence: true,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 99_999_999.999,
          }

        validates :dFab,
          presence: true

        validates :dVal,
          presence: true

        validates :vPMC,
          presence: true,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
          }
      end
    end
  end
end
