module Nfe
  module Models
    class NFeProc
      include ActiveModel::Model
      include Helpers::XmlModel::NfeModel

      attr_reader :nfe, :protNFe

      def initialize(nfe, protNFe)
        @nfe = nfe
        @protNFe = protNFe
      end

      def to_xml
        xml = Builder::XmlMarkup.new

        xml.nfeProc(xmlns: Models::NFe.namespace, versao: nfe.infNFe.versao) do |node|

          node << @nfe.to_xml

          node << @protNFe.to_xml

        end

        xml.target!
      end
    end
  end
end
