module Nfe
  module Models
    module Referenced
      class RefECF
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :mod, required: :true
        attr_xml :nECF, required: :true
        attr_xml :nCOO, required: :true

        validates :mod,
          presence: true,
          inclusion: { in: ["2B", "2C", "2D"] }

        validates :nECF,
          presence: true,
          length: { is: 3 }

        validates :nCOO,
          presence: true,
          length: { is: 6 }
      end
    end
  end
end
