module Nfe
  module Models
    module Referenced
      class RefNF
        include ActiveModel::Model
        include Concerns::Ufable
        include Helpers::XmlModel::NfeModel

        attr_xml :cUF, type: :integer, required: true
        attr_xml :aamm, required: :true, xml_alias: "AAMM"
        attr_xml :cnpj, required: :true, xml_alias: "CNPJ"
        attr_xml :mod, required: :true
        attr_xml :serie, required: :true
        attr_xml :nNF, required: :true

        validates :cUF,
          presence: true,
          length: { is: 2 }

        validates :aamm,
          presence: true,
          length: { is: 4 }

        validates :cnpj,
          cnpj: true,
          presence: true,
          length: { is: 14 }

        validates :mod,
          presence: true,
          length: { is: 2 }

        validates :serie,
          presence: true,
          length: { in: 1..3 }

        validates :nNF,
          presence: true,
          length: { in: 1..9 }
      end
    end
  end
end
