module Nfe
  module Models
    module Referenced
      class RefNFP
        include ActiveModel::Model
        include Concerns::CnpjCpfValidatable
        include Concerns::Ufable
        include Helpers::XmlModel::NfeModel

        attr_xml :cUF, type: :integer, required: true
        attr_xml :aamm, required: :true, xml_alias: "AAMM"
        attr_xml :cnpj, xml_alias: "CNPJ"
        attr_xml :cpf,  xml_alias: "CPF"
        attr_xml :ie, required: :true, xml_alias: "IE"
        attr_xml :mod, required: :true
        attr_xml :serie, required: :true
        attr_xml :nNF, required: :true

        validates :cUF,
          length: { is: 2 }

        validates :aamm,
          length: { is: 4 }

        validates :ie,
          ie: { uf: "uf" },
          length: { in: 2..14 }

        validates :mod,
          length: { is: 2 }

        validates :serie,
          length: { in: 1..3 }

        validates :nNF,
          length: { in: 1..6 }
      end
    end
  end
end
