require_relative "ICMSNormalBase"

module Nfe
  module Models
    module Taxes
      class ICMS00 < ICMSNormalBase

        attr_xml :modBC, type: :integer, required: true
        attr_xml :vBC, type: :float, required: true
        attr_xml :pICMS, type: :float, required: true
        attr_xml :vICMS, type: :float, required: true 

        validates :modBC,
          presence: true,
          numericality: true,
          inclusion: { in: [0, 1, 2, 3] }

        validates :vBC,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99
          }

        validates :pICMS,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 999.99
          }

        validates :vICMS,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99
          }

      end
    end
  end
end
