require_relative "ICMSSNBase"

module Nfe
  module Models
    module Taxes
      class ICMS101 < ICMSSNBase

        attr_xml :pCredSN, type: :float, required: true
        attr_xml :vCredICMSSN, type: :float, required: true

        validates :pCredSN,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 999.99
          }

        validates :vCredICMSSN,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99
          }

      end
    end
  end
end
