require_relative "ICMSNormalBase"

module Nfe
  module Models
    module Taxes
      class ICMS40 < ICMSNormalBase

        attr_xml :vICMSDeson, type: :float
        attr_xml :motDesICMS, type: :integer

        validates :vICMSDeson,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }

        validates :motDesICMS,
          inclusion: { in: [1, 2, 3, 4, 5, 6, 7, 8, 9], allow_blank: true }

      end
    end
  end
end
