require_relative "ICMSSNBase"

module Nfe
  module Models
    module Taxes
      class ICMS500 < ICMSSNBase

        attr_xml :vBCSTRet, type: :float
        attr_xml :vICMSSTRet, type: :float

        validates :vBCSTRet,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }

        validates :vICMSSTRet,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }

      end
    end
  end
end
