require_relative "ICMSNormalBase"

module Nfe
  module Models
    module Taxes
      class ICMS51 < ICMSNormalBase

        attr_xml :modBC, type: :integer
        attr_xml :pRedBC, type: :float
        attr_xml :vBC, type: :float
        attr_xml :pICMS, type: :float
        attr_xml :vICMS, type: :float

        validates :modBC,
          inclusion: { in: [0, 1, 2, 3], allow_blank: true }

        validates :pRedBC,
          numericality: {
            allow_blank: true,
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 999.99,
          }

        validates :vBC,
          numericality: {
            allow_blank: true,
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9999999999999.99
          }

        validates :pICMS,
          numericality: {
            allow_blank: true,
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 999.99
          }

        validates :vICMS,
          numericality: {
            allow_blank: true,
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9999999999999.99
          }

      end
    end
  end
end
