module Nfe
  module Models
    module Taxes
      class ICMSBase
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :orig, type: :integer, required: true

        validates :orig,
          presence: true,
          numericality: true,
          inclusion: { in: [0, 1, 2] }

        def self.root_name
          self.name.demodulize
        end
      end
    end
  end
end
