module Nfe
  module Models
    module Taxes
      class II
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :vBC, type: :float, required: true
        attr_xml :vDespAdu, type: :float, required: true
        attr_xml :vII, type: :float, required: true
        attr_xml :vIOF, type: :float, required: true

        validates :vBC,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99
          }

        validates :vDespAdu,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99
          }

        validates :vII,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99
          }

        validates :vIOF,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99
          }
      end
    end
  end
end
