module Nfe
  module Models
    module Taxes
      class ISSQNtot
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :vServ, type: :float
        attr_xml :vBC, type: :float
        attr_xml :vISS, type: :float
        attr_xml :vPIS, type: :float
        attr_xml :vCOFINS, type: :float

        validates :vServ,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }

        validates :vBC,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }

        validates :vISS,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }

        validates :vPIS,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }

        validates :vCOFINS,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }
      end
    end
  end
end
