module Nfe
  module Models
    module Taxes
      class PISCOFINSNT
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :cst, required: true, xml_alias: "CST"

        def self.csts
          ["04", "06", "07", "08", "09"]
        end

        validates :cst,
          presence: true,
          inclusion: { in: PISCOFINSNT.csts }
      end
    end
  end
end
