module Nfe
  module Models
    module Taxes
      class RetTrib
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :vRetPIS, type: :float
        attr_xml :vRetCOFINS, type: :float
        attr_xml :vRetCSLL, type: :float
        attr_xml :vBCIRRF, type: :float
        attr_xml :vIRRF, type: :float
        attr_xml :vBCRetPrev, type: :float
        attr_xml :vRetPrev, type: :float

        validates :vRetPIS,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }

        validates :vRetCOFINS,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }

        validates :vRetCSLL,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }

        validates :vBCIRRF,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }

        validates :vIRRF,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }

        validates :vBCRetPrev,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }

        validates :vRetPrev,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9_999_999_999_999.99,
            allow_blank: true
          }
      end
    end
  end
end
