module Nfe
  module Models
    class Total
      include ActiveModel::Model
      include Helpers::XmlModel::NfeModel

      attr_xml :icmsTot, type: :node, required: true, xml_alias: "ICMSTot"
      attr_xml :issqntot, type: :node, xml_alias: "ISSQNtot"
      attr_xml :retTrib, type: :node

      validates :icmsTot,
        presence: true

      validate { validate_optional_attributes :icmsTot, :issqntot, :retTrib }

      def initialize
        @icmsTot = Taxes::ICMSTot.new
        @issqntot = Taxes::ISSQNtot.new
        @retTrib = Taxes::RetTrib.new
      end
    end
  end
end
