module Nfe
  module Models
    module Transport
      class RetTransp
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :vServ, type: :float, required: true
        attr_xml :vBCRet, type: :float, required: true
        attr_xml :pICMSRet, type: :float, required: true
        attr_xml :vICMSRet, type: :float, required: true
        attr_xml :cfop, required: true, xml_alias: "CFOP"
        attr_xml :cMunFG, required: true

        validates :vServ,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9999999999999.99
          }

        validates :vBCRet,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9999999999999.99
          }

        validates :pICMSRet,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 999.99
          }

        validates :vICMSRet,
          numericality: {
            greater_than_or_equal_to: 0,
            less_than_or_equal_to: 9999999999999.99
          }

        validates :cfop,
          length: { is: 4 },
          numericality: { only_integer: true }

        validates :cMunFG,
          length: { is: 7 },
          numericality: { only_integer: true }
      end
    end
  end
end
