module Nfe
  module Models
    module Transport
      class Transporta
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :cnpj, xml_alias: "CNPJ"
        attr_xml :cpf, xml_alias: "CPF"
        attr_xml :xNome 
        attr_xml :ie, xml_alias: "IE"
        attr_xml :xEnder
        attr_xml :xMun
        attr_xml :uf, xml_alias: "UF"

        validates :cnpj,
          cnpj: true,
          length: { is: 14, allow_blank: true }

        validates :cpf,
          cpf: true,
          length: { is: 11, allow_blank: true }

        validates :xNome,
          length: { maximum: 60 }

        validates :ie,
          ie: { uf: "uf" },
          length: { in: 2..14, allow_blank: true }

        validates :xEnder,
          length: { maximum: 60 }

        validates :xMun,
          length: { maximum: 60 }

        validates :uf,
          length: { is: 2, allow_blank: true }
      end
    end
  end
end
