module Nfe
  module Models
    module Transport
      class VeicTranspReboque
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :placa, required: true
        attr_xml :uf, required: true, xml_alias: "UF"
        attr_xml :rntc, xml_alias: "RNTC"

        validates :placa,
          length: { is: 7 }

        validates :uf,
          length: { is: 2 }

        validates :rntc,
          length: { maximum: 20, allow_blank: true }
      end
    end
  end
end
