require_relative "base"

module Nfe
  module Operations
    class ConsultEmitter < Base

      def initialize(certificate, private_key, environment, uf, kind_of_document,
        document_number, use_schema: true)
        super(certificate, private_key, use_schema: use_schema)

        @uf = uf
        @environment = environment
        @kind_of_document = kind_of_document
        @document_number = document_number
      end

      protected
      def before_execute
        @object = object_to_send
      end

      def handle_result(xml)
        @result = Services::Regress::RetConsCad.new xml
      end

      def xpath
        "//ns:retConsCad"
      end

      def schema_name
        ws_info.schema
      end

      def ws_info
        Webservices::Wsinfo::ConsultEmitter.new(@environment, @uf)
      end

      private
      def object_to_send
        consCad = Services::Dispatch::ConsCad.new
        consCad.versao = ws_info.version
        consCad.tpAmb = @environment
        consCad.uf = @uf
        set_document consCad
        consCad
      end

      def set_document(object)
        case @kind_of_document
        when :ie
         object.ie = @document_number

        when :cnpj
          object.cnpj = @document_number

        else
          object.cpf = @document_number
        end
      end
    end
  end
end
