require_relative "event"

module Nfe
  module Operations
    class CorrectionLetter < Event
      def initialize(certificate:, private_key:, environment:, nfe_key:,
        sequential:, date_time:, correction:, use_schema: true)

        @event = object_event(correction)

        super(certificate, private_key, environment, nfe_key, sequential,
          date_time, @event, use_schema: use_schema)
      end

      def correction_letter_xml
        event_xml
      end

      protected
      def object_event(correction)
        event = Services::Dispatch::DetEventoCC.new

        event.xCorrecao = correction

        event
      end

      def valid?
        if @event.xCorrecao.to_s.length < 15
          errors.add(:base, I18n.t("correction_letter.invalid_correction"))
        end

        super
      end
    end
  end
end
