require_relative "base"

module Nfe
  module Operations
    class NfeSituation < Base
      def initialize(certificate, private_key, environment, nfe_key,
        use_schema: true)
        super(certificate, private_key, use_schema: use_schema)

        @nfe_key = nfe_key
        @environment = environment
      end

      protected
      def before_execute
        @object = object_to_send
      end

      def handle_result(xml)
        @result = Services::Regress::RetConsSitNFe.new xml
      end

      def xpath
        "//ns:retConsSitNFe"
      end

      def schema_name
        ws_info.schema
      end

      def ws_info
        Webservices::Wsinfo::NfeSituation.new(@environment, uf)
      end

      private
      def object_to_send
        Services::Dispatch::ConsSitNFe.new(@environment, uf, ws_info.version,
          @nfe_key)
      end

      def uf
        Helpers::NfeKey.parse(@nfe_key).uf
      end
    end
  end
end
