require_relative "base"

module Nfe
  module Operations
    class ServiceStatus < Base
      def initialize(certificate, private_key, environment, uf, use_schema: true)
        super(certificate, private_key, use_schema: use_schema)

        @uf = uf
        @environment = environment
      end

      protected
      def before_execute
        @object = object_to_send
      end

      def handle_result(xml)
        @result = Services::Regress::RetConsStatServ.new xml
      end

      def xpath
        "//ns:retConsStatServ"
      end

      def schema_name
        ws_info.schema
      end

      def ws_info
        Webservices::Wsinfo::ServiceStatus.new(@environment, @uf)
      end

      private
      def object_to_send
        consSitNFe = Services::Dispatch::ConsStatServ.new
        consSitNFe.versao = ws_info.version
        consSitNFe.tpAmb = @environment
        consSitNFe.uf = @uf
        consSitNFe
      end
    end
  end
end
