module Nfe
  module Services
    module Dispatch
      class ConsSitNFe
        include ActiveModel::Model

        attr_accessor :versao, :chNFe, :uf

        extend Enumerize

        enumerize :tpAmb, in: { production: 1, test: 2 }

        validates :versao,
          length: { is: 4 }

        validates :chNFe,
          length: { is: 44 }

        validates :uf,
          length: { is: 2 }

        def initialize(environment, uf, versao, chNFe)
          @tpAmb = environment
          @uf = uf
          @versao = versao
          @chNFe = chNFe
        end

        def to_xml
          xml = Builder::XmlMarkup.new

          xml.consSitNFe(xmlns: Models::NFe.namespace, versao: versao ) do |cons|
            cons.tpAmb tpAmb_value
            cons.xServ "CONSULTAR"
            cons.chNFe @chNFe
          end

          xml.target!
        end
      end
    end
  end
end
