module Nfe
  module Services
    module Dispatch
      class ConsStatServ
        include ActiveModel::Model
        include Models::Concerns::Ufable
        include Helpers::XmlModel::NfeModel

        attr_xml :tpAmb, type: :enumerize
        attr_xml :cUF
        attr_xml :xServ

        attr_accessor :versao

        extend Enumerize

        enumerize :tpAmb, in: { production: 1, test: 2 }

        validates :versao,
          length: { is: 4 }

        validates :cUF,
          length: { is: 2 }

        def to_xml
          xml = Builder::XmlMarkup.new

          xml.consStatServ(xmlns: Models::NFe.namespace, versao: versao ) do |cons|
            add_elements cons
          end

          xml.target!
        end

        private
        def xServ
          "STATUS"
        end
      end
    end
  end
end
