module Nfe
  module Services
    module Dispatch
      class DetEventoCC
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :descEvento
        attr_xml :xCorrecao, required: true
        attr_xml :xCondUso

        attr_accessor :versao

        validates :versao,
          length: { is: 4 }

        validates :xCorrecao,
          length: { in: 15..1000 }

        def kind
          :cce
        end

        def tpEvent
          110110
        end

        def to_xml
          xml = Builder::XmlMarkup.new

          xml.detEvento(versao: versao) { |node| add_elements node }

          xml.target!
        end

        private
        def descEvento
          "Carta de Correcao"
        end

        def xCondUso
          "A Carta de Correcao e disciplinada pelo paragrafo 1o-A do art. 7o "\
          "do Convenio S/N, de 15 de dezembro de 1970 e pode ser utilizada " \
          "para regularizacao de erro ocorrido na emissao de documento "\
          "fiscal, desde que o erro nao esteja relacionado com: I - as "\
          "variaveis que determinam o valor do imposto tais como: base de "\
          "calculo, aliquota, diferenca de preco, quantidade, valor da "\
          "operacao ou da prestacao; II - a correcao de dados cadastrais que "\
          "implique mudanca do remetente ou do destinatario; III - a data de "\
          "emissao ou de saida."
        end
      end
    end
  end
end
