module Nfe
  module Services
    module Dispatch
      class DetEventoCancel
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :descEvento
        attr_xml :nProt, required: true
        attr_xml :xJust, required: true

        attr_accessor :versao

        validates :versao,
          length: { is: 4 }

        validates :nProt,
          length: { is: 15 }

        validates :xJust,
          length: { in: 15..255 }

        def kind
          :nfe_cancel
        end

        def tpEvent
          110111
        end

        def to_xml
          xml = Builder::XmlMarkup.new

          xml.detEvento(versao: versao) { |node| add_elements node }

          xml.target!
        end
        private
        def descEvento
          "Cancelamento"
        end
      end
    end
  end
end
