module Nfe
  module Services
    module Dispatch
      class EnvEvento
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_accessor :idLote, :evento, :versao

        validates :idLote,
          length: { in: 1..15 }

        validate { validate_required_attributes :evento }

        def to_xml
          xml = Builder::XmlMarkup.new

          xml.envEvento({xmlns: Nfe::Models::NFe.namespace, versao: versao}) do |nfe|
            nfe.idLote idLote

            nfe << evento.to_xml
          end
          xml.target!
        end
      end
    end
  end
end
