module Nfe
  module Services
    module Dispatch
      class EnviNFe
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_accessor :lote, :nfe, :versao

        validates :lote,
          length: { in: 1..15 }

        validates :versao,
          presence: true,
          length: { is: 4 }

        validate { validate_required_attributes :nfe }

        def initialize(nfe, lote, version)
          @nfe = nfe
          @lote = lote
          @versao = version
        end

        def to_xml
          xml = Builder::XmlMarkup.new

          xml.enviNFe(xmlns: Models::NFe.namespace, versao: versao) do |env|

            env.idLote @lote

            env.indSinc SYNCHRONOUS

            env << @nfe.to_xml
          end

          xml.target!
        end

        private
        SYNCHRONOUS = 1
      end
    end
  end
end
