module Nfe
  module Services
    module Regress
      class RetEvento
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :versao, type: :attribute
        attr_xml :tpAmb, type: :enumerize
        attr_xml :verAplic, required: true
        attr_xml :cOrgao, required: true
        attr_xml :cStat, type: :integer, required: true
        attr_xml :xMotivo, required: true
        attr_xml :chNFe
        attr_xml :tpEvento
        attr_xml :xEvento
        attr_xml :nSeqEvento
        attr_xml :cnpjDest
        attr_xml :cpfDest
        attr_xml :emailDest
        attr_xml :dhRegEvento, type: :datetime
        attr_xml :nProt

        attr_accessor :id, :signature

        extend Enumerize

        enumerize :tpAmb, in: { production: 1, test: 2 }

        def parse!(xml)
          doc = Nokogiri::XML(xml)

          parse_elements doc

          if doc.css("infEvento").attribute("Id").present?
            @id = doc.css("infEvento").attribute("Id").text
          end

          signature = doc.xpath("//ds:Signature", ds: Models::Signature.namespace)
          @signature.parse!(signature.to_xml) if signature.present?
        end

        def to_xml
          xml = Builder::XmlMarkup.new

          xml.retEvento(versao: versao) do |root|
            attributes = {}
            attributes[:Id] = id if id.present?

            root.infEvento(attributes) do |node|
              add_elements node
            end
          end

          xml.target!
        end
      end
    end
  end
end
