module Nfe
  module Services
    module Regress
      class RetInutNFe
        include ActiveModel::Model
        include Helpers::XmlModel::NfeModel

        attr_xml :versao, type: :attribute, required: true
        attr_xml :tpAmb, type: :enumerize, required: true
        attr_xml :verAplic, required: true
        attr_xml :cStat, type: :integer, required: true
        attr_xml :xMotivo, required: true
        attr_xml :cUF, required: true
        attr_xml :ano, required: true
        attr_xml :cnpj, required: true, xml_alias: "CNPJ"
        attr_xml :mod, required: true
        attr_xml :serie, required: true
        attr_xml :nNFIni, required: true
        attr_xml :nNFFin, required: true
        attr_xml :dhRecbto, type: :datetime, required: true
        attr_xml :nProt, required: true

        attr_accessor :id

        extend Enumerize

        enumerize :tpAmb, in: { production: 1, test: 2 }

        def parse!(xml)
          doc = Nokogiri::XML(xml)

          if doc.css("infInut").attribute("Id").present?
            @id = doc.css("infInut").attribute("Id").text
          end

          parse_elements doc
        end

        def to_xml
          xml = Builder::XmlMarkup.new

          xml.retInutNFe(versao: versao) do |root|
            attributes = {}
            attributes[:Id] = @id if @id.present?

            root.infInut(attributes) do |node|
              add_elements node
            end
          end

          xml.target!
        end
      end
    end
  end
end
