module Nfe
  module Webservices
    class ClientSoap
      def initialize(certificate, private_key, webserviceinfo)
        @client = Savon.client(
          log: false,
          wsdl: webserviceinfo.url,
          soap_version: 2,
          ssl_cert: certificate,
          ssl_cert_key: private_key,
          ssl_verify_mode: :none,
          adapter: :httpclient)
        @webserviceinfo = webserviceinfo
      end

      def call(xml)
        @client.call @webserviceinfo.service, soap_header: header, message: xml
      end

      private
      def header
        { nfeCabecMsg:
          { "@xmlns" => @webserviceinfo.namespace,
            cUF: uf_code,
            versaoDados: @webserviceinfo.version
          }
        }
      end

      def uf_code
        Nfe::Helpers::UfHelper.code(@webserviceinfo.uf)
      end
    end
  end
end
