module Nfe
  module Webservices
    module Wsinfo
      class Factory
        def self.create_wsdl(environment, uf)
          env = environment.capitalize
          sefaz = sefaz_by(uf).capitalize

          Wsinfo::const_get(env).const_get(sefaz).new
        rescue NameError
          raise(ArgumentError, I18n.t("webservice.environment_uf.invalid",
            environment: environment, uf: uf))
        end

        private
        SVAN = ["ES", "MA", "PA", "PI"]
        SVRS = ["AC","AL","AP","DF","PB","RJ","RN","RO","RR","SE","TO","SC"]

        def self.sefaz_by(uf)
          if SVAN.include? uf
            "svan"
          elsif SVRS.include? uf
            "svrs"
          else
            uf
          end
        end
      end
    end
  end
end
