module Xmldsig
  class Transforms

    def initialize(transforms)
      @transforms = transforms
    end

    def apply(node)
      @node = node
      @transforms.each do |transform_node|
        @node = transformer(@node, transform_node).transform
      end
      @node
    end

    private
    def transformer(node, transform_node)
      case transform_node.get_attribute("Algorithm")
        when "http://www.w3.org/2000/09/xmldsig#enveloped-signature"
          Xmldsig::EnvelopedSignature.new(node, transform_node)
        when "http://www.w3.org/2001/10/xml-exc-c14n#",
            "http://www.w3.org/TR/2001/REC-xml-c14n-20010315",
            "http://www.w3.org/2006/12/xml-c14n11"
          Xmldsig::Canonicalize.new(node, transform_node)
      end
    end
  end
end
